/*
**	Imager-LP DLL Header
**		version 1.9.1
*/
/*
Copyright(c)2014-2018 ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	IMAGER_LP_DLL_H
#define	IMAGER_LP_DLL_H

#include <Windows.h>

#ifdef IMAGERDLL_EXPORTS
#define MLPAPI __declspec(dllexport)
#else
#define MLPAPI __declspec(dllimport)
#endif
#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#include "MlpError.h"
#include "MlpDeclaration.h"

#ifdef	_UNICODE
#define	MlpInitialize			MlpInitializeW
#define	MlpLoadInitFile			MlpLoadInitFileW
#define	MlpLoadInitData			MlpLoadInitDataW
#define	MlpOpenDoc				MlpOpenDocW
#define	MlpOpenDocUsage			MlpOpenDocUsageW
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordW
#define	MlpValidateUserPassword		MlpValidateUserPasswordW
#define	MlpSetCMYKProfile		MlpSetCMYKProfileW
#define	MlpSetRGBProfile		MlpSetRGBProfileW
#define	MlpPageToPict			MlpPageToPictW
#define	MlpCreatePict			MlpCreatePictW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpRangeToTiff			MlpRangeToTiffW
#define	MlpCreateTiffRange		MlpCreateTiffRangeW
#define	MlpMultiPageToTiff		MlpMultiPageToTiffW
#define	MlpCreateTiffMulti		MlpCreateTiffMultiW
#define	MlpLicenseInfoStr		MlpLicenseInfoStrW
#define MlpPdfDocInfoEntry		MlpPdfDocInfoEntryW
#define MlpPanelToFile			MlpPanelToFileW
#define MlpSetDefaultFont		MlpSetDefaultFontW
#define MlpSetAlternateFont		MlpSetAlternateFontW
#define MlpSetAlternateFont2	MlpSetAlternateFont2W
#define MlpSetAlternateFontEx	MlpSetAlternateFontExW
#define MlpPaintRectToPanel2	MlpPaintRectToPanel2W
#define MlpSetImageWatermark	MlpSetImageWatermarkW
#define MlpSetFillTextWatermark	MlpSetFillTextWatermarkW
#define MlpSetStrokeTextWatermark MlpSetStrokeTextWatermarkW
#else
#define	MlpInitialize			MlpInitializeA
#define	MlpLoadInitFile			MlpLoadInitFileA
#define	MlpLoadInitData			MlpLoadInitDataA
#define	MlpOpenDoc				MlpOpenDocA
#define	MlpOpenDocUsage			MlpOpenDocUsageA
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordA
#define	MlpValidateUserPassword		MlpValidateUserPasswordA
#define	MlpSetCMYKProfile		MlpSetCMYKProfileA
#define	MlpSetRGBProfile		MlpSetRGBProfileA
#define	MlpPageToPict			MlpPageToPictA
#define	MlpCreatePict			MlpCreatePictA
#define	MlpConvertToTiff		MlpConvertToTiffA
#define	MlpRangeToTiff			MlpRangeToTiffA
#define	MlpCreateTiffRange		MlpCreateTiffRangeA
#define	MlpMultiPageToTiff		MlpMultiPageToTiffA
#define	MlpCreateTiffMulti		MlpCreateTiffMultiA
#define	MlpLicenseInfoStr		MlpLicenseInfoStrA
#define MlpPdfDocInfoEntry		MlpPdfDocInfoEntryA
#define MlpPanelToFile			MlpPanelToFileA
#define MlpSetDefaultFont		MlpSetDefaultFontA
#define MlpSetAlternateFont		MlpSetAlternateFontA
#define MlpSetAlternateFont2	MlpSetAlternateFont2A
#define MlpSetAlternateFontEx	MlpSetAlternateFontExA
#define MlpPaintRectToPanel2	MlpPaintRectToPanel2A
#define MlpSetImageWatermark	MlpSetImageWatermarkA
#define MlpSetFillTextWatermark	MlpSetFillTextWatermarkA
#define MlpSetStrokeTextWatermark MlpSetStrokeTextWatermarkA
#endif

#ifdef	__cplusplus
extern "C" {
#endif

MLPAPI int WINAPI MlpInitializeW(const wchar_t *license);
MLPAPI int WINAPI MlpInitializeA(const char *license);
MLPAPI void WINAPI MlpUninitialize();

MLPAPI int WINAPI MlpLoadInitFileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpLoadInitFileA(const char *fileName);
MLPAPI int WINAPI MlpLoadInitDataA(const char *dta, int len);

MLPAPI int WINAPI MlpOpenDocW(const wchar_t *fileName, const wchar_t *ownerPassword, const wchar_t *userPassword);
MLPAPI int WINAPI MlpOpenDocA(const char *fileName, const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenDocUsageW(const wchar_t *fileName, const wchar_t *password, int usage);
MLPAPI int WINAPI MlpOpenDocUsageA(const char *fileName, const char *password, int usage);
MLPAPI int WINAPI MlpOpenMemDoc(unsigned char *data, size_t len,  const char *owner_pw, const char *user_pw);
MLPAPI int WINAPI MlpOpenMemDocUsage(unsigned char *data, size_t len, const char *pass, int usage);
MLPAPI void WINAPI MlpCloseDoc();

MLPAPI int WINAPI MlpGetLibraryInfo(int cmd, ...);
MLPAPI void WINAPI MlpShowLicenseInfo();
MLPAPI int WINAPI MlpLicenseInfoStrA(char *licenseStrPtr);

MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
MLPAPI int WINAPI MlpPageCount();
MLPAPI int WINAPI MlpGetPageRotation(int pageNum, int *rotate);
MLPAPI int WINAPI MlpGetPageBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPicturePixel(int pageNum, int *x, int *y);
MLPAPI int WINAPI MlpGetPicturePixelX(int pageNum);
MLPAPI int WINAPI MlpGetPicturePixelY(int pageNum);
MLPAPI int WINAPI MlpGetCid0GlyphMode();
MLPAPI int WINAPI MlpPrintRestriction();

MLPAPI int WINAPI MlpSetPicturec(int opt, int val);
MLPAPI int WINAPI MlpSetPicture(int opt, ...);
MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
MLPAPI int WINAPI MlpSetPictureRGB();
MLPAPI int WINAPI MlpSetPictureCMYK();
MLPAPI int WINAPI MlpSetPictureGray();
MLPAPI int WINAPI MlpSetPictureBW();
MLPAPI int WINAPI MlpSetPictureDither();
MLPAPI int WINAPI MlpSetPictureFaxG3();
MLPAPI int WINAPI MlpSetPictureFaxG4();
MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
MLPAPI int WINAPI MlpSetPictureQuality(int quality);
MLPAPI int WINAPI MlpSetPicturePixelX(int x);
MLPAPI int WINAPI MlpSetPicturePixelY(int y);
MLPAPI int WINAPI MlpSetXYPicturePixel(int y);
MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
MLPAPI int WINAPI MlpSetTiffCompress(int mode);
MLPAPI int WINAPI MlpSetEnableAntialis();
MLPAPI int WINAPI MlpSetDisableAntialis();
MLPAPI int WINAPI MlpSetFillPathAAEnable();
MLPAPI int WINAPI MlpSetFillPathAADisable();
MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);
MLPAPI int WINAPI MlpSetPictureBufSize(int mb);

MLPAPI int WINAPI MlpValidateOwnerPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateOwnerPasswordW(const wchar_t *pass);
MLPAPI int WINAPI MlpValidateUserPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateUserPasswordW(const wchar_t *pass);

MLPAPI int WINAPI MlpSetCallbackFunc(int mode, int opt, void *function);

MLPAPI int WINAPI MlpSetCMYKProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetRGBProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetRGBProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetColorConversion(int color_convert_direction, int flag);
MLPAPI int WINAPI MlpSetColorConvertForImage(int color_convert_direction, int flag);	//no longer support
MLPAPI int WINAPI MlpUnuseColorProfile();

MLPAPI int WINAPI MlpSetDefaultFontW(const wchar_t *defaultFont);
MLPAPI int WINAPI MlpSetDefaultFontA(const char *defaultFont);
MLPAPI int WINAPI MlpSetAlternateFontW(const wchar_t *org, const wchar_t *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFontA(const char *org, const char *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFont2W(const wchar_t *org, const wchar_t *alt, const wchar_t *weight, const wchar_t *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFont2A(const char *org, const char *alt, const char *weight, const char *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFontExW(const wchar_t *org, const wchar_t *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_italic, int weight, int style, int variant, Matrix *transform);
MLPAPI int WINAPI MlpSetAlternateFontExA(const char *org, const char *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_italic, int weight, int style, int variant, Matrix *transform);

MLPAPI int WINAPI MlpSetImageWatermarkW(const wchar_t *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetImageWatermarkA(const char *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *color, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *color, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkA(const char *text, const char *fontName, int x_position, int y_position, int z_position, float fontSize, const char *color, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkA(const char *text, char const *fontName, int x_position, int y_position, int z_position, float fontSize, const char *color, float alpha);
MLPAPI int WINAPI MlpClearWatermarkData();


MLPAPI int WINAPI MlpPageToPictW(int pageNumber, int dpi, int quality, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpPageToPictA(int pageNumber, int dpi, int quality, const char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictW(int pageNumber, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictA(int pageNumber, const char *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffW(int startPageNum, int endPageNum, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffA(int startPageNum, int endPageNum, int dpi, const char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayW(int pageNumArray[], int length, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayA(int pageNumArray[], int length, const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiW(const char *pageList, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiA(const char *pageList, const char *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffW(const char *pageList, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffA(const char *pageList, int dpi, const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeW(int startPageNum, int endPageNum, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeA(int startPageNum, int endPageNum, const char *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffW(const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffA(const char *outputFilePath);

MLPAPI int WINAPI MlpCreatePictBufPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpCreatePictBufPageRange(int firstPageNumber, int lastPageNumber);
MLPAPI int WINAPI MlpCreatePictBufPageArray(int pages[], int len);
MLPAPI int WINAPI MlpCreatePictMem(int pageNumber);

MLPAPI int WINAPI MlpGetPictFromMem(unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpGetPictFromMemIndex(int index, unsigned char **pixels, int *width, int *height, int *nOfColors, int *pageNumber);
MLPAPI int WINAPI MlpGetPictFromMemPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpFreePictMem();

MLPAPI int WINAPI MlpGetOcgCount();
MLPAPI int WINAPI MlpGetOcgData(MlpOcgData *data[]);
MLPAPI int WINAPI MlpGetOcgUsage(MlpOcgUsage *usage[]);
MLPAPI int WINAPI MlpSetOcgState(MlpOcgData data[]);
MLPAPI int WINAPI MlpSetOcgStateU(MlpOcgUsage data[]);

MLPAPI int WINAPI MlpSetTextWidgetMultilineFontSize(float size);
MLPAPI float WINAPI MlpGetTextWidgetMultilineFontSize();
MLPAPI int WINAPI MlpSetTextWidgetMultilineUseLastSize(int use);
MLPAPI int WINAPI MlpGetTextWidgetMultilineUseLastSize();

MLPAPI int WINAPI MlpCreatePanel(int width, int height, int colorspace);
MLPAPI int WINAPI MlpClearPanel();
MLPAPI int WINAPI MlpFreePanel();
MLPAPI int WINAPI MlpPanelToFileA(const char *filePath);
MLPAPI int WINAPI MlpPanelToFileW(const wchar_t *filePath);
MLPAPI int WINAPI MlpMemPictToPanel(int x, int y, float alpha);
MLPAPI int WINAPI MlpMemPictToPanelBBox(int panel_xpos, int panel_ypos, float alpha, int bbox_xpos, int bbox_ypos, int bbox_width, int bbox_height);
MLPAPI int WINAPI MlpPaintRectToPanel(int xpos, int ypos, int width, int height, int lineWidth, unsigned char color[]);
MLPAPI int WINAPI MlpPaintRectToPanel2A(int xpos, int ypos, int width, int height, int lineWidth, char *color);
MLPAPI int WINAPI MlpPaintRectToPanel2W(int xpos, int ypos, int width, int height, int lineWidth, wchar_t *color);

MLPAPI int WINAPI MlpPrsGetFontInfo(PrsFontName **fontNameArray, int *len);
MLPAPI int WINAPI MlpPrsGetFontInfoWithTr(PrsFontName **fontNameArray, int *len);

MLPAPI int WINAPI Imager();
MLPAPI int WINAPI XrefStream();
MLPAPI int WINAPI MetaStream();
MLPAPI int WINAPI ThumbObj();
MLPAPI int WINAPI ExceptionTest();
MLPAPI int WINAPI ExtractText();
MLPAPI int WINAPI ExtractText2();
MLPAPI int WINAPI ExtractImage(int object_number);

MLPAPI int WINAPI MlpCreatePngFromPixels(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);
MLPAPI int WINAPI MlpCreatePngFromPixelsWAlpha(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);

#ifdef	__cplusplus
}
#endif

#endif	/*IMAGER_LP_DLL_H*/
